## ros-rolling-rosbag2-storage-mcap 0.24.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(rosbag2_storage_mcap)

# Set Release build if no build type was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Build type for the build. Possible values are: Debug, Release, RelWithDebInfo, MinSizeRel"
      FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
      "Debug" "Release" "RelWithDebInfo" "MinSizeRel")
endif()

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

# Enable additional warnings and warnings as errors
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(mcap_vendor REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosbag2_storage REQUIRED)

ament_python_install_package(ros2bag_mcap_cli)

add_library(${PROJECT_NAME} SHARED
  src/mcap_storage.cpp
)
target_include_directories(${PROJECT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include/${PROJECT_NAME}>
)
target_compile_features(${PROJECT_NAME} PUBLIC c_std_99 cxx_std_17)
target_compile_definitions(${PROJECT_NAME} PRIVATE "ROSBAG2_STORAGE_MCAP_BUILDING_DLL")
target_link_libraries(${PROJECT_NAME}
  mcap_vendor::mcap
  pluginlib::pluginlib
  rcutils::rcutils
  rosbag2_storage::rosbag2_storage
)

set(MCAP_COMPILE_DEFS)
# COMPATIBILITY(foxy) - 0.3.x is the Foxy release
if(${rosbag2_storage_VERSION} VERSION_GREATER_EQUAL 0.4.0)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_HAS_STORAGE_OPTIONS)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_WRITER_CREATES_DIRECTORY)
endif()
# COMPATIBILITY(galactic) - 0.9.x is the Galactic release
if(${rosbag2_storage_VERSION} VERSION_GREATER_EQUAL 0.10.0)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_OVERRIDE_SEEK_METHOD)
endif()
# COMPATIBILITY(foxy, galactic) - 0.15.x is the Humble release
if(${rosbag2_storage_VERSION} VERSION_GREATER_EQUAL 0.15.0)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_HAS_YAML_HPP)
endif()
# COMPATIBILITY(foxy, galactic, humble, rolling:0.17.x)
if(${rosbag2_storage_VERSION} VERSION_GREATER_EQUAL 0.17.0)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_HAS_STORAGE_FILTER_TOPIC_REGEX)
endif()
# COMPATIBILITY(foxy, galactic, humble, rolling:0.17.x, rolling:0.18.x)
if(${rosbag2_storage_VERSION} VERSION_GREATER_EQUAL 0.18.0)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_HAS_SET_READ_ORDER)
  list(APPEND MCAP_COMPILE_DEFS ROSBAG2_STORAGE_MCAP_HAS_UPDATE_METADATA)
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE ${MCAP_COMPILE_DEFS})

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "ROSBAG2_STORAGE_MCAP_BUILDING_LIBRARY")

pluginlib_export_plugin_description_file(rosbag2_storage plugin_description.xml)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(rcpputils REQUIRED)
  find_package(rosbag2_test_common REQUIRED)
  find_package(std_msgs REQUIRED)

  add_definitions(-D_TEST_RESOURCES_DIR_PATH="${CMAKE_CURRENT_SOURCE_DIR}/test/${PROJECT_NAME}")

  set(ament_cmake_clang_format_CONFIG_FILE .clang-format)
  list(APPEND AMENT_LINT_AUTO_EXCLUDE ament_cmake_uncrustify)
  if(WIN32)
    # clang-format is not easily exposed to Windows, this linter enforced regardless via Linux/OSX builds
    list(APPEND AMENT_LINT_AUTO_EXCLUDE ament_cmake_clang_format)
  endif()
  ament_lint_auto_find_test_dependencies()

  ament_add_gmock(test_mcap_storage test/rosbag2_storage_mcap/test_mcap_storage.cpp)
  target_link_libraries(test_mcap_storage
    ${PROJECT_NAME}
    rosbag2_storage::rosbag2_storage
    rosbag2_test_common::rosbag2_test_common
    ${std_msgs_TARGETS}
  )
  target_compile_definitions(test_mcap_storage PRIVATE ${MCAP_COMPILE_DEFS})

endif()


ament_export_libraries(${PROJECT_NAME})
ament_export_targets(export_${PROJECT_NAME})
ament_export_dependencies(rosbag2_storage rcutils)

ament_package()

=== debian/changelog ===
ros-rolling-rosbag2-storage-mcap (0.24.0-1jammy) jammy; urgency=high

  * Implement storing and loading ROS_DISTRO from metadata.yaml and mcap files (#1241 <https://github.com/ros2/rosbag2/issues/1241>)
  * Contributors: Emerson Knapp

 -- Foxglove <ros-tooling@foxglove.dev>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.23.0-1jammy) jammy; urgency=high



 -- Foxglove <ros-tooling@foxglove.dev>  Fri, 28 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.22.0-1jammy) jammy; urgency=high

  * Add type_hash in MessageDefinition struct (#1296 <https://github.com/ros2/rosbag2/issues/1296>)
  * Add message definition read API (#1292 <https://github.com/ros2/rosbag2/issues/1292>)
  * rosbag2_storage: add type description hash to topic metadata (#1272 <https://github.com/ros2/rosbag2/issues/1272>)
  * Contributors: Michael Orlov, james-rms

 -- Foxglove <ros-tooling@foxglove.dev>  Tue, 18 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.21.0-1jammy) jammy; urgency=high

  * rosbag2_cpp: move local message definition source out of MCAP plugin (#1265 <https://github.com/ros2/rosbag2/issues/1265>)
  * Update rosbag2 to C++17. (#1238 <https://github.com/ros2/rosbag2/issues/1238>)
  * Use target_link_libraries instead of ament_target_dependencies (#1202 <https://github.com/ros2/rosbag2/issues/1202>)
  * Contributors: Chris Lalancette, Daisuke Nishimatsu, Michael Orlov, james-rms

 -- Foxglove <ros-tooling@foxglove.dev>  Wed, 12 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.20.0-1jammy) jammy; urgency=high

  * CLI: Get storage-specific values from plugin (#1209 <https://github.com/ros2/rosbag2/issues/1209>)
  * Contributors: Emerson Knapp

 -- Foxglove <ros-tooling@foxglove.dev>  Tue, 14 Feb 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.19.0-1jammy) jammy; urgency=high

  * Add Michael Orlov as maintainer in rosbag2 packages (#1215 <https://github.com/ros2/rosbag2/issues/1215>)
  * rosbag2_cpp: test more than one storage plugin (#1196 <https://github.com/ros2/rosbag2/issues/1196>)
  * set_read_order: return success (#1177 <https://github.com/ros2/rosbag2/issues/1177>)
  * rosbag2_storage_mcap: merge into rosbag2 repo (#1163 <https://github.com/ros2/rosbag2/issues/1163>)
  * Contributors: Michael Orlov, james-rms

 -- Foxglove <ros-tooling@foxglove.dev>  Fri, 13 Jan 2023 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.6.0-1jammy) jammy; urgency=high

  * mcap_storage: 'none' is a valid storage preset profile (#86 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/86>)
  * mcap_storage: handle update_metadata call (#83 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/83>)
  * Update clang-format rules to fit ROS 2 style guide (#80 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/80>)
  * Revert "read_order: throw exception from set_read_order for unsupported orders"
  * read_order: throw exception from set_read_order for unsupported orders
  * Fix compile flags to work on rosbag_storage:0.17.x (#78 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/78>)
  * Fix Windows build (#73 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/73>)
  * Contributors: Andrew Symington, Emerson Knapp, James Smith, james-rms

 -- Foxglove <ros-tooling@foxglove.dev>  Mon, 28 Nov 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.5.0-1jammy) jammy; urgency=high

  * set defaults for SQLite plugin parity (#68 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/68>)
  * rosbag2_storage_mcap: add storage preset profiles (#57 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/57>)
  * rename test_fixture_interfaces package to testdata (#64 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/64>)
  * Switch to using the vendored zstd library. (#59 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/59>)
  * Add set_read_order reader API (#54 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/54>)
  * Contributors: Chris Lalancette, Emerson Knapp, James Smith

 -- Foxglove <ros-tooling@foxglove.dev>  Wed, 02 Nov 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.4.0-1jammy) jammy; urgency=high

  * Some minor improvements in rosbag2_storage_mcap after review (#58 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/58>)
  * Revert "rosbag2_storage_mcap: add storage preset profiles"
  * rosbag2_storage_mcap: add storage preset profiles
  * Contributors: James Smith, Michael Orlov

 -- Foxglove <ros-tooling@foxglove.dev>  Thu, 06 Oct 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.3.0-1jammy) jammy; urgency=high

  * Store IDL message definitions in Schema records when no MSG definition is available (#43 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/43>)
  * Contributors: James Smith

 -- Foxglove <ros-tooling@foxglove.dev>  Fri, 09 Sep 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.2.0-1jammy) jammy; urgency=high

  * Support timestamp-ordered playback (#50 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/50>)
  * Support regex topic filtering
  * Contributors: James Smith

 -- Foxglove <ros-tooling@foxglove.dev>  Thu, 08 Sep 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.1.7-1jammy) jammy; urgency=high

  * Add all lz4 sources to fix undefined symbols at runtime (#46 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/46>)
  * Contributors: Emerson Knapp

 -- Foxglove <ros-tooling@foxglove.dev>  Mon, 15 Aug 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.1.6-1jammy) jammy; urgency=high

  * Upgrade mcap to fix LZ4 error and segfault (#42 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/42>)
  * Contributors: Jacob Bandes-Storch

 -- Foxglove <ros-tooling@foxglove.dev>  Fri, 22 Jul 2022 00:00:00 -0000

ros-rolling-rosbag2-storage-mcap (0.1.5-1jammy) jammy; urgency=high

  * Fix build for Foxy (#34 <https://github.com/ros-tooling/rosbag2_storage_mcap/issues/34>)


=== debian/control ===
Source: ros-rolling-rosbag2-storage-mcap
Section: misc
Priority: optional
Maintainer: Foxglove <ros-tooling@foxglove.dev>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-clang-format <!nocheck>, ros-rolling-ament-cmake-gmock <!nocheck>, ros-rolling-ament-cmake-python, ros-rolling-ament-index-cpp, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-mcap-vendor, ros-rolling-pluginlib, ros-rolling-rcpputils <!nocheck>, ros-rolling-rcutils, ros-rolling-rosbag2-storage, ros-rolling-rosbag2-test-common <!nocheck>, ros-rolling-std-msgs <!nocheck>, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rosbag2-storage-mcap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ament-index-cpp, ros-rolling-mcap-vendor, ros-rolling-pluginlib, ros-rolling-rcutils, ros-rolling-rosbag2-storage, ros-rolling-ros-workspace
Description: rosbag2 storage plugin using the MCAP file format

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rosbag2-storage-mcap//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
